﻿from tkinter import *
import math
#■大域的変数の宣言
global A,B,C,D,C1,canvas,DSP
#■データ定義
A=complex(0.7 , 0.2)
B=complex(0   , 0  )
C=complex(0   , 0  )
D=complex(0.67, 0  )
DSP=[40,120,300,300,'#007700','#007700']
#■共役複素数
def conj(Z):
    return complex(Z.real,-Z.imag)
#■畑写像のための関数
def f0(Z):
    return A*Z+B*conj(Z)
def f1(Z):
    return C*(Z-1)+D*(conj(Z)-1)+1
#■複素数による点描画
def drawPoint(Z):
    CL=DSP[4]    #虚数部の正と負で色を変える
    if Z.imag<0:
        CL=DSP[5]
    IX=int(DSP[0]+Z.real*DSP[2]+0.5)
    IY=int(DSP[1]-Z.imag*DSP[3]+0.5)
    #すべての点を消すことができるようtagを付けておく
    canvas.create_rectangle(IX,IY,IX,IY,fill=CL, outline='',tag="HATA")
#■描画
def drawRec(N,Z):
    if N==0:
        drawPoint(Z)
    else:
        drawRec(N-1,f0(Z))
        drawRec(N-1,f1(Z))
#■メイン処理
tk=Tk()
tk.title("畑政義写像")
canvas=Canvas(tk, width=350,height=200)
canvas.pack()
canvas.delete("HATA")
drawRec(14,complex(0))
tk.update()
tk.mainloop()    




    
